/*
 * Hemos implementado algunas funciones matemáticas para asegurarnos de recibir
 * la respuesta esperada en cada caso, incluyendo matices denostados por las
 * funciones de biblioteca o implementando funcionalidades inexistentes.
 */

exports.difAng = function (v1, v2){
    /* v1 - v2 diferencia angular */

    // Convertimos los vectores sobre los que operaremos a coordenadas polares
    var pol_v1 = aPolares(v1);
    var pol_v2 = aPolares(v2);
    
    // Restamos los argumentos de los vectores en polares
    var dif = pol_v1[1] - pol_v2[1];

    // Nos aseguramos de abatir por el camino más corto. Para mas detalle sobre el algoritmo
    // consultese la documentacion
    if (Math.abs(dif) >= Math.PI){
        if(dif >= 0){
            return (-(2*Math.PI - dif))%(2*Math.PI);	
        }else{
            return (2*Math.PI + dif)%(2*Math.PI);
        }
    }else{
        return dif;	
    }
}

function aPolares(v){
    /*
     * Esta funcion convierte el vector v (que viene en cartesianas) a polares
     */
    r = Math.sqrt(Math.pow(v[0], 2)+Math.pow(v[1], 2)); //módulo
    ang = (Math.atan(v[1]/v[0])); //argumento en el primer cuadrante
    ang0_2PI = considerarCuadrante(v, ang); //argumento en toda la circunferencia
    return [r, ang0_2PI];
}

function considerarCuadrante(v, ang){
    /*
     * Damos recorrido de 0 a 2*pi a la respuesta de atan() que responde en el 1er cuadrante por defecto.
     * v es el vector en cartesianas y ang el argumento despues de convertirlo a polares. v[0] es la
     * componente x mientras que v[1] es la componente y.
     */
    
    var dev;	
    switch(true){
        // Si v esta en el primer cuadrante
        case (v[0]>=0 && v[1]>=0):
            dev = ang;
            break;
        // Si v esta en el segundo cuadrante
        case (v[0]<0 && v[1]>=0):
            dev = Math.PI+ang;
            break;
        // Si v esta en el tercer cuadrante
        case (v[0]<0 && v[1]<0):
            dev = Math.PI+ang;
            break;
        // Si v esta en el cuarto cuadrante
        case (v[0]>=0 && v[1]<0):
            dev = 2*Math.PI+ang;
            break;
    }
    return dev%(2*Math.PI);
}


