 /* mariaDB command for running this script:" \. /<path>/init.sql" without final semicolon

  * Getting Started with MariaDB - Second Edition [1-78528-412-6; 1-78217-571-7] Bartholomew, Daniel Ao:2015 :
  * http://exlibris.upv.es:3410/sfxlcl41?ctx_ver=Z39.88-2004&ctx_enc=info:ofi/enc:UTF-8&ctx_tim=2017-03-10T12%3A31%3A06IST&url_ver=Z39.88-2004&url_ctx_fmt=infofi/fmt:kev:mtx:ctx&rfr_id=info:sid/primo.exlibrisgroup.com:primo3-Journal-dawson&rft_val_fmt=info:ofi/fmt:kev:mtx:&rft.genre=book&rft.atitle=&rft.jtitle=&rft.btitle=Getting%20Started%20with%20MariaDB&rft.aulast=&rft.auinit=&rft.auinit1=&rft.auinitm=&rft.ausuffix=&rft.au=Daniel%20Bartholomew&rft.aucorp=&rft.volume=&rft.issue=&rft.part=&rft.quarter=&rft.ssn=&rft.spage=&rft.epage=&rft.pages=&rft.artnum=&rft.issn=&rft.eissn=&rft.isbn=&rft.sici=&rft.coden=&rft_id=info:doi/&rft.object_id=&svc_val_fmt=info:ofi/fmt:kev:mtx:sch_svc&svc.fulltext=yes&rft_dat=<dawson>9781782168102</dawson><grp_id>7735483127485047468</grp_id><oa></oa><url></url>&rft.eisbn=9781782168102&rft_id=info:oai/&req.language=spa
  *
  * https://mariadb.com/kb/en/sql-99/constraint_type-foreign-key-constraint/
  *
  * https://mariadb.com/kb/en/mariadb/constraint/#foreign-key-constraints
  */
/*
 * Hay que crear un usuario cuyas credenciales coincidan con las configuradas en logica.js
 * create user <user>;
 * set password to consultor = PASSWORD('<password>');
 * grant SELECT * FROM SatInfo.* to <user>;
 */

drop table if exists Canal;
drop table if exists Transpondedor;
drop table if exists Idioma;
drop table if exists CanalIdioma;
drop table if exists Huella;

create table Idioma(
	cod_iso char(3),
	idioma varchar(50),
	primary key(cod_iso)
);

create table Transpondedor(
	TID char(5) not null,
	sateliteNORAD char(6) not null,
	nombre_sat varchar(50) not null,
	posicion char(4),
	nombre_huella varchar(50),
	primary key(TID)
);

create table Huella(
	posicion char(4) not null,
	nombre_huella varchar(50) not null,
	huella varchar(10000),
	primary key(posicion, nombre_huella)
);

create table Canal(
	localID int not null,
	TID char(5) not null references Transpondedor(TID),
	SID char(5) not null,
	VPID char(3) not null,
	nombre varchar(50) not null,
	frecuencia char(5) not null, -- en MHz
	polaridad char(1) not null, -- ser V para Vertical y H para Horizontal
	encriptacion varchar(50),
	tipo char(6), 
	resolucion char(3), -- SD/HD/UHD?
	URL char(30),
	SymbolRate char(5), -- SymbolRate en KBaudios 
	FEC char(3),
	codificacion char(8), -- hoy en da slo existen DVB-S y DVB-S2, pero damos 8 caracteres por si hay nuevas mtodos
	modulacion char(5), -- QPSK, 8PSK, 16PSK...
	compresion char(7), -- MPEG-4...
--	fecha date,
	primary key(localID)
);

create table CanalIdioma(
	TID char(5) references Canal(TID),
	SID char(5) references Canal(SID),
	VPID char(3) references Canal(VPID),
	cod_iso char(3) references Idioma(cod_iso),
	primary key(TID,SID, VPID,cod_iso)
);

/* Valores de prueba
 * \. /home/satinfo/Dropbox/4/TFG/Codigo/v0/SatInfo/init.sql

insert into Idioma values ('eng', 'english');
insert into Idioma values ('esp', 'spanish');
insert into Idioma values ('fra', 'french');
/*------------------------------------------------------
insert into Canal values ('11200', '99999', 'Paramount', '11700', 'V', 'asdfasdf', 'T', 'SD', 'www.asdfasdf.com', '23000', '3/4', 'DVB-S2', '16PSK');
insert into Canal values ('11200', '99998', 'Discovery', '11700', 'V', 'asdfasdf', 'T', 'SD', 'www.asdfasdf.com', '23000', '3/4', 'DVB-S2', '16PSK');
insert into Canal values ('11200', '99997', 'Telecinco', '11700', 'V', 'asdfasdf', 'T', 'SD', 'www.asdfasdf.com', '23000', '3/4', 'DVB-S2', '16PSK');

insert into Canal values ('11201', '99996', 'Fox', '14500', 'H', 'qwerqwer', 'T', 'UHD', 'www.qwerqwer.com', '26000', '1/2', 'DVB-S2', '64PSK');
insert into Canal values ('11201', '99995', 'National Geographic', '12000', 'V', 'poiupoiu', 'T', 'UHD', 'www.pouipoiu.com', '26000', '1/2', 'DVB-S2', '64PSK');
/*------------------------------------------------------
insert into CanalIdioma values ('11200', '99999', 'eng');
insert into CanalIdioma values ('11200', '99999', 'esp');
insert into CanalIdioma values ('11200', '99999', 'fra');

insert into CanalIdioma values ('11200', '99998', 'eng');
insert into CanalIdioma values ('11200', '99998', 'fra');

insert into CanalIdioma values ('11200', '99997', 'esp');

insert into CanalIdioma values ('11201', '99996', 'eng');
insert into CanalIdioma values ('11201', '99996', 'esp');

insert into CanalIdioma values ('11201', '99995', 'fra');
insert into CanalIdioma values ('11201', '99995', 'esp');
/*------------------------------------------------------
insert into Transpondedor values ('11200', 'norad1', 'Satelite 1', 'E20', '00001');
insert into Transpondedor values ('11201', 'norad2', 'Satelite 2', 'E20', '00002');
insert into Transpondedor values ('11202', 'norad3', 'Satelite 3', 'E20', '00003');
 */
/* Acciones de prueba
 *

select cod_iso from CanalIdioma inner join Canal on CanalIdioma.SID=Canal.SID where Canal.SID='99998';
 */
