var huellasPendientes, huellasGuardadas, posicion, nombre_huella, map, draw, huella_low, huella_medium, huella_high;

function getHuellas(){
    /*
     * Esta funcion obtiene del servidor las huellas, tanto de las que se conoce el dibujo,
     * como las que están pendientes de dibujar, diferenciando entre estos estados.
     */
    console.log("getHuellas()");
    
    // Utilizamos la biblioteca XMLHttpRequest para implementar los mensajes REST
    var xmlHttp = new XMLHttpRequest();
    xmlHttp.open(	"GET", 'http://127.0.0.1:8080/huellas/', true ); //false for synchronus
    xmlHttp.send();
    
    // Detectamos la respuesta del servidor
    xmlHttp.onreadystatechange = function(){
        if(xmlHttp.readyState == 4 && xmlHttp.status == 200){
            // Guardamos en las variables globales definidas para este fin las posiciones y nombres
            // de las huellas, tanto pendientes como aquellas que ya están dibujadas (guardadas)
            huellasPendientes = JSON.parse(xmlHttp.responseText)[0];
            huellasGuardadas = JSON.parse(xmlHttp.responseText)[1];
            
            // Si huellasPendientes queda vacío significa que no hay huellas pendientes por dibujar
            if(!huellasPendientes[0]){
                document.getElementById('checkboxes').innerHTML = "No hay huellas pendientes de dibujar.";
            }else{
                // Si hay huellas pendientes de dibujar, las pasamos a la funcion que las ofrecerá en los desplegables correspondientes
                actualizarDesplegableHllPendientes(huellasPendientes);
            }
            
            // Si huellasGuardadas queda vacío significa que no hay dibujos de huellas guardados en el servidor
            if(!huellasGuardadas[0]){
                document.getElementById('mensaje').innerHTML = "No hay huellas guardadas que mostrar.";
            }else{
                // Si hay huellas cuyo trazo está guardado, se las pasamos a la función que las ofrecerá en los desplegables correspondientes
                actualizarDesplegablePosHllGuardadas(huellasGuardadas);
            }
        }
    }
}

function guardarHuella(){
    /*
     * Esta funcion recoge los trazos del usuario, la posicion y el nombre de la huella dibujada y los envia al 
     * servidor para que almacene la informacion en la BBDD.
     */
    console.log("guardarHuella()");
    
    // Construimos el objeto que enviaremos en el cuerpo de la peticion HTTP
    var huellas = {"low": huella_low, "medium": huella_medium, "high": huella_high};				
    var datosDeHuella =	{	'posicion':	huellasPendientes[document.getElementById('posicion_sel').value].posicion,
                                'nombre_huella':huellasPendientes[document.getElementById('posicion_sel').value].beams[getChecked()],
                                'huellas':	huellas
                        };
    
    // Si las comprobaciones de rigor resultan exitosas procedemos al envio
    if(comprobaciones(datosDeHuella)){
        var xmlHttp = new XMLHttpRequest();
        xmlHttp.open( "POST", 'http://127.0.0.1:8080/huellas/', true ); // false for synchronous
        xmlHttp.send( JSON.stringify(datosDeHuella) );
    }
}

function anadirLinea(){
    /*
     * Esta funcion guarda la linea que acaba de dibujar el usuario en la variable
     */
    console.log("anadirLinea()");
    
    // Guardamos en nodelist la lista de marcadores de tipo radio que determinan el nivel de potencia que esta dibujando el usuario
    var nodelist = document.getElementsByName('ganancia');
    
    // Dependiendo del selector radio que hay marcado guardamos el dibujo en una variable
    switch(true){
        case nodelist[0].checked: 
            huella_low = draw.getAll().features[draw.getAll().features.length-1].geometry.coordinates[0]; break;
            //console.log("huella_low: "+huella_low);
        case nodelist[1].checked: 
            huella_medium = draw.getAll().features[draw.getAll().features.length-1].geometry.coordinates[0]; break;
            //console.log("huella_med: "+huella_medium);
        case nodelist[2].checked: 
            huella_high = draw.getAll().features[draw.getAll().features.length-1].geometry.coordinates[0]; break;
            //console.log("huella_high: "+huella_high);
    }
}

function actualizarDesplegableHllPendientes(){
    /*
     * Esta funcion actualiza el desplegable de las huellas pendientes de dibujar con la informacion contenida en
     * la variable huellasPendientes.
     */
    console.log("actualizarDesplegableHllPendientes()");
    
    // Buscamos por su id el desplegable
    var desplegable = document.getElementById('posicion_sel');
    // Recorremos huellasPendientes y añadimos la opcion correspondiente a cada elemento
    for(var i = 0; i <= huellasPendientes.length-1; i++){
        desplegable.innerHTML += "<option value='"+i+"'>"+huellasPendientes[i].posicion+"</option>";
    }
    // Pasamos a actualizar los checkboxes que ofrecen los distintos nombre_huella
    actualizarCheckboxes();
}

function actualizarCheckboxes(){
    /*
     * Esta funcion actualiza los selectores de tipo radio con los que el usuario elige el nombre de la huella
     * que esta dibujando. Dependiendo de la posicion elegida se ofrecen los nombres que contiene.
     */
    console.log("actualizarCheckboxes()");
    
    // Detectamos que posicion orbital es la que se encuentra marcada y la guardamos como posicionSeleccionada
    var posicionSeleccionada = document.getElementById('posicion_sel').value;
    
    // Buscamos la etiqueta de los checkboxes por su id
    var checkboxes = document.getElementById('checkboxes');
    // Vaciamos la etiqueta para rellenarla
    checkboxes.innerHTML = '';
    // Guardamos el array que contiene los nombres disponibles en la posicion en una variable para recorrerla
    var huellasDeLaPosicion = huellasPendientes[posicionSeleccionada].beams;
    
    // Recorremos la variable con los nombres y añadimos el codigo correspondiente por cada elemento de la misma
    for(var i = 0; i <= huellasDeLaPosicion.length-1; i++){
        checkboxes.innerHTML += "<input type='radio' name='nombre_huella' value='"+i+"'>"+huellasDeLaPosicion[i]+"<br>";
    }
}

function actualizarDesplegablePosHllGuardadas(){
    /*
     * Esta funcion actualiza el desplegable de las posiciones de las huellas dibujadas guardadas en
     * la BBDD con la informacion contenida en la variable huellasGuardadas.
     */
    console.log("actualizarDesplegablePosHllGuardadas()");
    
    // Buscamos por su id el desplegable
    var desplegable = document.getElementById('posicion_guardadas');
    
    // Recorremos huellasGuardadas y añadimos la opcion correspondiente a cada elemento
    for(var i = 0; i <= huellasGuardadas.length-1; i++){
        desplegable.innerHTML += "<option value='"+i+"'>"+huellasGuardadas[i].posicion+"</option>";
    }
    // Pasamos a actualizar el desplegable que recoge los nombres disponibles para la posicion seleccionada
    actualizarDesplegableNomHllGuardadas();
}

function actualizarDesplegableNomHllGuardadas(){
    /*
     * Esta funcion actualiza el desplegable de los nombres de las huellas dibujadas guardadas en
     * la BBDD con la informacion contenida en la variable huellasGuardadas.
     */
    console.log("actualizarDesplegableNomHllGuardadas()");
    
    // Detectamos la posicion seleccionada
    var posicionSeleccionada = document.getElementById('posicion_guardadas').value;
    
    // Guardamos el array que contiene los nombres disponibles en la posicion en una variable para recorrerla
    var nombres = huellasGuardadas[posicionSeleccionada].beams;
    // Buscamos por su id el desplegable
    var desplegable = document.getElementById('nombre_guardadas');
    
    // Recorremos nombres y añadimos la opcion correspondiente a cada elemento
    for(var i = 0; i <= nombres.length-1; i++){
        desplegable.innerHTML += "<option value='"+i+"'>"+nombres[i]+"</option>";
    }
}

function getChecked(){
    /*
     * Esta funcion devuelve el indice marcado en la lista de selectores radio
     * que ofrece los nombres de huellas pendientes de dibujar.
     */
    
    // Obtenemos la lista de selectores por su nombre
    var nodelist = document.getElementsByName('nombre_huella');
    // La recorremos hasta encontrar el elemento marcado, devolviendo el indice
    for(var i = 0; i <= nodelist.length-1; i++){
        var bol = nodelist[i].checked;
        if(bol){
            return i;
        }
    }
}

function comprobaciones(datosDeHuella){
    /*
     * Comprobamos que el usuario ha actuado correctamente para evitar errores en el servidor
     */
    
    // Comprobamos que el atributo huellas no sobrepasa el límite implementado en la BBDD
    if(JSON.stringify(datosDeHuella.huellas).length > 10000){
        alert("Límite de puntos para definir la huella sobrepasado. Recargue la página y defina la huella con menos puntos.")
        return false;
    }
    // Comprobamos que se está indicando a qué nivel de potencia corresponde el dibujo que se está efectuando
    if(!datosDeHuella.nombre_huella){
        alert("Marque el nombre de la huella que está dibujando.");
        return false;
    }
    // Comprobamos que se han guardado en sus respectivas variables las líneas de los 3 niveles de potencia considerados
    if(!(datosDeHuella.huellas.low && datosDeHuella.huellas.medium && datosDeHuella.huellas.high)){
        alert("Dibuje el área de cobertura para los 3 niveles de ganancia requeridos.");
        return false;
    }
    return true;
}

function visualizar(){
    /*
     * Esta función dibuja en el mapa las líneas que definen las áreas de cobertura de la huella seleccionada
     * con los desplegables.
     */
    console.log("visualizar()");
    
    // Pedimos al servidor el dibujo de la huella seleccionada
    var xmlHttpV = new XMLHttpRequest();
    xmlHttpV.open( "POST", 'http://127.0.0.1:8080/dibujo/', true ); // false for synchronous
    var posicion = huellasGuardadas[document.getElementById('posicion_guardadas').value].posicion;
    var nombre = huellasGuardadas[document.getElementById('posicion_guardadas').value].beams[document.getElementById('nombre_guardadas').value];
    xmlHttpV.send(JSON.stringify({"posicion": posicion, "nombre_huella": nombre}));
    
    // Tomamos la respuesta del servidor...
    xmlHttpV.onreadystatechange = function(){
        if(xmlHttpV.readyState == 4 && xmlHttpV.status == 200){
            
            huellas = JSON.parse(xmlHttpV.responseText);
            // ... y la dibujamos sobre el mapa
            map.addLayer({
                    'id': 'maine',
                    'type': 'fill',
                    'source': {
                        'type': 'geojson',
                        'data': {
                            'type': 'Feature',
                            'geometry': {
                                'type': 'Polygon',
                                'coordinates':   [huellas.low,
                                                  huellas.medium,
                                                  huellas.high
                                                 ]
                            }
                        }
                    },
                    'layout': {},
                    'line-join': "miter",
                    'paint': {
                        'fill-opacity': 0.6
                    }
            });
            
        }
    }
}

function borrar(){
    /*
     * Esta función permite eliminar de la BBDD un dibujo almacenado anteriormente.
     */
    
    // Obtenemos la posicion y nombre seleccionadas en los desplegables de huellas guardadas con anterioridad
    var posicion = huellasGuardadas[document.getElementById('posicion_guardadas').value].posicion;
    var nombre = huellasGuardadas[document.getElementById('posicion_guardadas').value].beams[document.getElementById('nombre_guardadas').value];
    
    // Lanzamos pop-up de confirmación al usuario 
    var mensaje = confirm("¿Estás seguro de que quieres borrar la huella "+posicion+" / "+nombre+" de la base de datos?");
    // En caso de confirmación enviamos la solicitud HTTP al servidor para que elimine la entrada de la BBDD
    if(mensaje){
        var xmlHttpB = new XMLHttpRequest();
        xmlHttpB.open( "POST", 'http://127.0.0.1:8080/borrar/', true );
        xmlHttpB.send(JSON.stringify({"posicion": posicion, "nombre_huella": nombre}));
    }
}

function mostrarMapa(){
    /*
     * Esta es la función que carga el mapa de biblioteca mapbox en la web.
     */
    mapboxgl.accessToken = 'pk.eyJ1IjoibHVpc21sIiwiYSI6ImNqMnVpcHJzdDAwOHgyeW81MnU4ajdxcngifQ.skJWDa6KI3BScVD3PNWRIQ';
    map = new mapboxgl.Map({
        container: 'map', // container id
        style: 'mapbox://styles/mapbox/streets-v9', //stylesheet location
        center: [5, 45], // starting position
        zoom: 3 // starting zoom
    });
    
    // Permitimos introducir dibujos poligonales por parte del usuario
    draw = new MapboxDraw({
        displayControlsDefault: false,
        controls: {
            polygon: true,
            trash: false
        }
    });
    map.addControl(draw);
}